stages:
  - build
  - test

include:
  - template: Code-Quality.gitlab-ci.yml

image: docker:20.10.16

services:
  - docker:20.10.16-dind

.maven_cache: &maven_cache
  - key:
      files:
        - pom.xml
    paths:
      - .m2/repository/

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository"
  JDK_VERSION: "17"

build:
  stage: build
  cache:
    - *maven_cache
  before_script:
    - apk update
    - apk add --no-cache openjdk$JDK_VERSION
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - chmod +x ./mvnw
  script:
    - ./mvnw clean spring-boot:build-image -Dspring-boot.build-image.imageName=app
    - |
        if [[ $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH ]]; then
            docker tag app $CI_REGISTRY_IMAGE:latest
            docker push $CI_REGISTRY_IMAGE:latest
        fi
    - |
        if [[ $CI_COMMIT_TAG ]]; then
            docker tag app $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
            docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
        else
            docker tag app $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-b$CI_PIPELINE_IID
            docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-b$CI_PIPELINE_IID
        fi

test:
  stage: test
  cache:
    - *maven_cache
  before_script:
    - apk update
    - apk add --no-cache openjdk$JDK_VERSION
    - chmod +x ./mvnw
  script:
    - ./mvnw clean test
